%Builds the KNN model
k=20;
testpoint=[100,100,75,30]
data=load(strcat('CondensedDataMean\data.mat'));
data=data.data;
data=data(:,[1,2,4,5]);
%datatofind = data(testpoint,:)%[15225 0.4224 0.78 0.15 1.61]
target=load(strcat('CondensedDataMean\target.mat'));
target=target.target;
dataset=load(strcat('results\','length',int2str(testpoint(1)),'width',int2str(testpoint(2)),'curve',int2str(testpoint(3)),'branch',int2str(testpoint(4))));
dataset=dataset.results;
expectedtarget=testpoint;
%expectedtarget=target(testpoint,:)
%model = KDTreeSearcher(data);
model = ExhaustiveSearcher(data,'Distance','seuclidean');%'seuclidean');%'mahalanobis');
%model = fitcknn(data,target);
display('Model Built')
RMSE=zeros(100,1);
diff=zeros(100,4);
perdiff=zeros(100,4);
datatofind=zeros(1,4);
para=zeros(100,4);
for i=1:1:100
    datatofind(1,:)=dataset(4,i,[1,2,4,5]);
    ind = knnsearch(model,datatofind,'K',k);
    knn=target(ind(:),:);
    pred=knn;
    pred = mean(knn);
    para(i,:)=pred;
    display(strcat('length',int2str(pred(1)),'width',int2str(pred(2)),'curve',int2str(pred(3)),'branch',int2str(pred(4))))
    RMSE(i) = sqrt(mean((expectedtarget-pred).^2));
    diff(i,:) =abs(expectedtarget-pred);
    perdiff(i,:) = (abs(expectedtarget-pred)./expectedtarget)*100;
end
RMSE=mean(RMSE)
diff=mean(diff)
perdiff=mean(perdiff)
para=mean(para)